#include <stdio.h>
#include <stdlib.h>
#include <xc.h>
#include "spi_tools.h"
#include "adf7030_tools.h"
#include "pin_config.h"
#include <sys/attribs.h>

#include "CS_def_NOT_sensor_board.h"

/*
 NOTE: We were able to retest this code before submission. The last time it was 
 * used, it was used for a specific test which require some code by changed.
 * The code has been reverted back to what is believed to be the proper order, 
 * but there may be errors. Specifically, the test was used to receive a packet
 * and transmit a different packet rather than the same packet.
 * 
 * Also, I believe one of the pins relating to ADF interrupts is broken. I do 
 * not recall which pin on which board, but I can guess from the commented out
 * "Set Pin3 to be IRQ_OUT0" in the code below. I think the error was with one 
 * of the purple boards, not one of the transceiver boards. Based on that error,
 * I would guess the affected pin is the pin on one of the purple boards 
 * that corresponds to GPIO3 on the tranceiver board.
 */


/*Used for the test
uint8_t payload_buff_relay[] = {
        #include "payload_100B_relay.txt"
    };
uint32_t RX_SIZE;
*/
void setup_adf_rx_tx();


void __ISR (_EXTERNAL_2_VECTOR, IPL7SRS)
    INT2Handler(void)
    {
        write_bits(IRQ_CTRL_STATUS0,1,11,1);        //Clear the SM_IDLE interrupt
        IFS0bits.INT2IF = 0;
   //////////////////////////////////////// Not sure if I need this
        //poll_CMDREADY_IDLE();
   ////////////////////////////////////     
        radio_command(PHY_RX);
    }

void config_int2_int()
{
    ANSELBbits.ANSB15 = 0;      //turn off analog on B15
    TRISBbits.TRISB15 = 1;      //make input
    INT2Rbits.INT2R = 0b0011;   //assign ext int 2 to RPB15 (GP0)
    IFS0bits.INT2IF = 0;        //reset flag
    IPC3bits.INT2IP = 7;        //priority 7
    INTCONbits.INT2EP = 1;      //polarity rising edge
    IEC0bits.INT2IE = 1;        //enable 
}


 
void config_general_int()
{
    __builtin_enable_interrupts();  //global interrupt enable
    INTCONbits.MVEC = 1;            //Multi vector interrupt 
}


int main(int argc, char** argv) 
{
    setup_adf_rx_tx();
///////////////    Used for the test
//    write_BPL(0,payload_buff_relay,RX_SIZE);                                          //Write payload_buff to transmit buffer
////////////

    
    config_general_int();
    config_int2_int();

    
    while(1){}

    return (EXIT_SUCCESS);
}




void setup_adf_rx_tx()
{
    reset_radio();      
    enableSPICMD();                                                             //Enables SPI commands to be sent to radio
    spi_init();                                                                 //Enable PIC SPI
     
    poll_CMDREADY_IDLE();                                                       //Configure ADF
    configRadio();                                                              //Configure ADF

    RX_SIZE = 100;                                                     //Set RX_SIZE = 100
    write_bits(GENERIC_PKT_BUFF_CFG1,9,0,RX_SIZE);                              //Set RX_SIZE = 100
    write_bits(GENERIC_PKT_FRAME_CFG1,12,0,RX_SIZE);                            //Set Payload Size to RX_SIZE
    
    write_bits(PROFILE_REF_CLK_CFG,1,26,1);                                     //Modify configuration such that CLK_TYPE = 1 (oscillator is XTAL)
    calibrateRadio();                                                           //Write calibration file to memory
    write_RnPL(SM_DATA_CALIBRATION, CAL_ENABLE);
////// SET up ADF interrupt
    write_bits(IRQ_CTRL_MASK0,1,11,1);                                          //set SM_IDLE_IRQ0
//    write_bits(PROFILE_GPCON0_3,6,24,0x6);                                      //Set Pin3 to be IRQ_OUT0
    write_bits(PROFILE_GPCON0_3,6,0,0x6);                                       //Set Pin0 to be IRQ_OUT0
///////
    radio_command(CFG_DEV);                                                     //Send command to do configuration
    poll_CMDREADY_IDLE();                                                       //Wait for CMD_READY, TRANSITION_STATE==IDLE
    radio_command(PHY_ON);                                                      //Sequence to perform calibration
    poll_CMDREADY_IDLE(); 
    radio_command(DO_CAL);
    poll_CMDREADY_IDLE(); 
    write_RnPL(SM_DATA_CALIBRATION, CAL_DISABLE);
    
    uint32_t PTR_RX_BASE = read_bits(GENERIC_PKT_BUFF_CFG0,11,0);               //Get PTR_RX_BASE default value
    uint32_t PTR_RX = PTR_RX_BASE*4 + 0x20000000;                               //Determine PTR_RX
    set_pntr(PTR_RX,1);                                                         //set pointer 1 as RX payload pointer
    write_bits(GENERIC_PKT_BUFF_CFG0,11,11,PTR_RX_BASE);                        //set PTR_TX = PTR_RX (RX and TR payload pointers are same: 1)
////////////////////
/* Used for the test
    uint32_t PTR_TX_BASE = read_bits(GENERIC_PKT_BUFF_CFG0,11,11);               //Get PTR_RX_BASE default value
    uint32_t PTR_TX = PTR_TX_BASE*4 + 0x20000000;                               //Determine PTR_RX
    set_pntr(PTR_TX,0);     
*/
////////////////////    
    
    //Setup auto turn around for RX->TX
    write_bits(GENERIC_PKT_BUFF_CFG1,1,29,1);
    //Setup auto turn around for TX->RX
//    write_bits(GENERIC_PKT_BUFF_CFG1,1,31,1);
    poll_CMDREADY_IDLE();
}
