#include "spi_tools.h"
#include <xc.h>

//#include "CS_def_sensor_board.h"
#include "CS_def_NOT_sensor_board.h"

/*-----------------------------------------------------------------------*/
/* Initialize SPI interface     */
/*-----------------------------------------------------------------------*/
void spi_init(){
    
    IEC4bits.SPI3EIE = 0;
    IEC4bits.SPI3RXIE = 0;
    IEC4bits.SPI3TXIE = 0;
    
    /*
    ETHCON1bits.ON = 0;
    ETHCON1bits.RXEN = 0;
    
    ANSELEbits.ANSE5 = 0;
*/
    SDI3R = 0b0101;         //assign SDI3 (MISO) to RPB9
    RPB10R = 0b0111;        //assign RPB10 to SDO3 (MOSI)
    
    SPI3CONbits.ON = 0;     // Turn off the SPI during config
    SPI3BUF = 0;            // Clear the SPI buffer
    SPI3CONbits.ENHBUF = 0;
    SPI3BRG = 31;              // TODO: Change Clock speed
    
    SPI3STATbits.SPIROV = 0;
    SPI3CONbits.MSTEN = 1;      // Set master mode
    SPI3CONbits.MSSEN = 0;
    SPI3CONbits.MODE16 = 0;
    SPI3CONbits.MODE32 = 0;
    SPI3CONbits.SMP = 1;
    SPI3CONbits.CKP = 0;
    SPI3CONbits.CKE = 1;
    
    SPI3CONbits.ON = 1;
    
//    ANSELBbits.ANSB7 = 0;       // Set CS pin to digital
//    TRISBbits.TRISB7 = 0;       //CS output
//    LATBbits.LATB7 = 1;
    ANSEL_CS = 0;
    TRIS_CS = 0;
    LAT_CS = 1;
}


char spi_write(char c)
{
    SPI3BUF = c;                // Write to the buffer
    while (!SPI3STATbits.SPIRBF);
    Nop();
    
    return SPI3BUF;
}
